#include <stdio.h>
#include <string.h>

void printHex(char s[]) {
  int i;
  char ch;
  for (i=0; i<24; i++) {
    ch = (s[i]) & 0xff; printf("%2.2X", ch);
  }
  printf("\n");
  for (i=24; i<48; i++) {
    ch = (s[i]) & 0xff; printf("%2.2X", ch);
  }
  printf("\n");
}

int main(void) {
  char plain[100], cipher[100];
  char key [16]={0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77,
                 0x88,0x99,0xaa,0xbb,0xcc,0xdd,0xee,0xff};
  char seed[16]={0x77,0x66,0x55,0x44,0x33,0x22,0x11,0x00,
                 0x88,0x99,0xaa,0xbb,0xcc,0xdd,0xee,0xff};

  strcpy(cipher, "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx");

  strcpy(plain,  "[the plain text 123456789a123456789b123456789c ]");
  AES ("Encrypt", key, seed, 48, plain, cipher);
  strcpy(plain,  "................................................");
  AES ("Decrypt", key, seed, 48, plain, cipher);
  printf("%s\n", plain);
  printHex(cipher);

  strcpy(plain,  "[The plain text 123456789a123456789b123456789c ]");
  AES ("Encrypt", key, seed, 48, plain, cipher);
  strcpy(plain,  "................................................");
  AES ("Decrypt", key, seed, 48, plain, cipher);
  printf("%s\n", plain);
  printHex(cipher);

  strcpy(plain,  "[The plain text  23456789a123456789b123456789c ]");
  AES ("Encrypt", key, seed, 48, plain, cipher);
  strcpy(plain,  "................................................");
  AES ("Decrypt", key, seed, 48, plain, cipher);
  printf("%s\n", plain);
  printHex(cipher);
  getchar();
  return 0;
}
